// framesdi.cpp : Defines the class behaviors for the application.
#include "common1.h"
#pragma hdrstop

#include "framesdi.h"

#include "mainfrm.h"
#include "framedoc.h"
#include "framevw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFramesdiApp

BEGIN_MESSAGE_MAP(CFramesdiApp, CWinApp)
	//{{AFX_MSG_MAP(CFramesdiApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFramesdiApp construction

CFramesdiApp::CFramesdiApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	
	// These Wildcat System function calls must be done in the order shown or Poof!
	
	/* 1 - Loads and initializes the cloadsys library*/ 
	if(!LoadWcSystemLibrary()){
	  AfxMessageBox("System Library did not load", MB_ICONSTOP|MB_OK, 0);
	  }	
	/* 2 - Loads and initializes the cloadpxy library */
	if(!LoadProxyLibrary()){
      AfxMessageBox("Proxy Library did not load", MB_ICONSTOP|MB_OK, 0);
	  }	
	/* 3 - Checks to see if the Connection Manager has started */
	if(!IsConnectionManagerStarted()){
	  AfxMessageBox("Connection Manager not started", MB_ICONSTOP|MB_OK, 0);
	  }	
	/* 4 - Checks to see if the Connection Manager is online with WC5 */
	if(!IsConnectionManagerOnline()){
	  AfxMessageBox("Connection Manager not online", MB_ICONSTOP|MB_OK, 0);
	  }	
	/* 5 - Starts up the wildcat navigator - passes current application window */
	WildcatNavigatorStartup(AfxGetMainWnd()->GetSafeHwnd(), 0);	
}
/////////////////////////////////////////////////////////////////////////////
// CFramesdiApp destructor

CFramesdiApp::~CFramesdiApp()
{
	// TODO: add destruction / cleanup code here
	
	// These Wildcat System function calls must be done in the order shown or Poof!
	
	/* 1 - Performs cleanup after the client shuts down */
	WildcatNavigatorCleanup(AfxGetMainWnd()->GetSafeHwnd());
	
	/* 2 - Free up the memory used by the cloadsys and cloadpxy libraries */
	FreeWcSystemLibrary();
	FreeProxyLibrary();	
	
}
/////////////////////////////////////////////////////////////////////////////
// The one and only CFramesdiApp object

CFramesdiApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CFramesdiApp initialization

BOOL CFramesdiApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	SetDialogBkColor();        // Set dialog background color to gray
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CFramesdiDoc),
		RUNTIME_CLASS(CMainFrame),     // main SDI frame window
		RUNTIME_CLASS(CFramesdiView));
	AddDocTemplate(pDocTemplate);

	// create a new (empty) document
	OnFileNew();

	if (m_lpCmdLine[0] != '\0')
	{
		// TODO: add command line processing here
	}


	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CFramesdiApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}
