// uoline.cpp : implementation file
//

#include "common1.h"
#include "framesdi.h"
#include "uoline.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUOline dialog


CUOline::CUOline(CWnd* pParent /*=NULL*/)
	: CDialog()
{
	//{{AFX_DATA_INIT(CUOline)
	m_EditTimer = 5; // sets default variable value for edit box 
	nTimer = SetTimer(1, 5000, NULL);  // set's timer to 5 second interval
	//}}AFX_DATA_INIT
	
	/* Do create AFTER setting any variable default values or they will be
	   overwritten!
	*/
	Create(IDD_UONLINE, pParent ); 
}

void CUOline::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUOline)
	DDX_Text(pDX, IDC_EDITTIMER, m_EditTimer);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUOline, CDialog)
	//{{AFX_MSG_MAP(CUOline)
	ON_BN_CLICKED(IDC_UPDATELIST, OnUpdatelist)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CUOline message handlers
//////////////////////////////////////////////////////////////
// PostNcDestroy():     This function is called after the window has been
//                      destroyed.  Therefore, it is used for deleting
//                      the object's memory.
//

void CUOline::PostNcDestroy()
{
  delete this;   // frees dialog memory
}

void CUOline::OnOK() 
{
  KillTimer(nTimer); // we are done, so kills timer...
  DestroyWindow();   // destroys dialog box
}

void CUOline::OnUpdatelist()
{
	int t1 = 0;
	UpdateData(TRUE);  // updates m_EditTimer with new typed in number 
	
	/* variable in edit box (m_EditTimer) * 1000 milliseconds = seconds of delay
	    requested in edit box.
  */
	    
	t1 = m_EditTimer * 1000;  
	
	nTimer = SetTimer(1, t1, NULL);	// resets timer to seconds we typed in edit box
}

void CUOline::OnTimer(UINT nIDEvent)
{
	CDialog::OnTimer(nIDEvent);  // allows timer to do others things as required
	
	/* on timer expiration we send a message to WM_UPDATEWHOSONLINE in the MAINFRM.CPP
	    message map.  Note: The timer is reset automatically and begins counting again
	    until we tell it to stop by destroying the dialog box.
	*/	
	AfxGetMainWnd()->SendMessage(WM_UPDATEWHOSONLINE);
}

BOOL CUOline::OnInitDialog()
{
  CDialog::OnInitDialog(); // calls ancestor class
  return TRUE;
}